// 京东SKU页面，会刷新页面重新载入，直接采集即可，每次一页
// https://item.jd.com/10077100293507.html
// 1.在网页URL上增加_jyfirst_=1
// 2.如果返回的数据颜色和尺码都是第一个时，location去掉_jyfirst_，开始采集。
// 3.颜色下尺码如果采集到最后一个后，url切换为下一个颜色且加上_jynext_=1
// 4.如果当前尺码为第一个时，location去掉_jynext_，开始采集
//img30.360buyimg.com/shaidan/s616x405_jfs/t1/105950/32/46759/478019/662894bbF508f288b/c0f5757b1f830744.jpg
//img30.360buyimg.com/n0/s48x48_jfs/t1/105950/32/46759/478019/662894bbF508f288b/c0f5757b1f830744.jpg

// JD评价缩略图
//img30.360buyimg.com/n0/s48x48_jfs/t1/229865/21/16447/204969/66598e9fF1727080a/d7e0546da22fae5d.jpg
// JD评价缩略图 对应的 图片
//img30.360buyimg.com/shaidan/s616x405_jfs/t1/229865/21/16447/204969/66598e9fF1727080a/d7e0546da22fae5d.jpg
(function () {
    // 打印版本号
    console.log('jd.sku@1.2.1')
    const locationHref = window.location.href
    const isJyFirst = getUrlParam(locationHref, '_jyfirst_') === '1'
    const isJyNext = getUrlParam(locationHref, '_jynext_') === '1'

    const defaultTimeout = 3000
    // 连接后台
    const port = chrome.runtime.connect({ name: 'content' })
    // 结果数据
    const results = []
    // 选中的当前分类index
    let cate1ItemElIndex = 0, cate2ItemElIndex = 0
    // 分类1和分类2,分类1下的项目
    let cate1ElList, cate2ElList, cate1SkuItemElList, cate2SkuItemElList
    // 当前选中的项目
    let currCate1ItemEl, currCate2ItemEl
    // 选择器
    let selectors = {}
    let selectors1 = {}
    // 评价.selectors.commentSelectors
    let commentSelectors = {}
    // 默认使用selectors,1为selectors1
    let selectorType = 0
    // 没有颜色尺码
    let noCateElList = false;

    // 采集评价任务
    const isCommentTask = getUrlParam(window.location, '_jytype_') === 'comment'

    // 监听后台消息{cmd:collect/collect-next,rdms:延时毫秒,tlcs: jdListCollectSelectors}
    port.onMessage.addListener((msg) => {
        const msgCmd = msg.cmd;

        console.log('jd.sku.onMessage', msg)
        // 已经连接 - 延时3秒获取数据
        if (msgCmd === 'connected') {
            setTimeout(() => {
                const body = document.body;
                if (body) {
                    body.style.border = '5px solid #3877cc';
                    const bar = document.createElement("div");
                    bar.style = 'background:#e74747;color:#fff;text-align:center;padding:10px;font-size:24px;font-weight:bold;';
                    bar.innerHTML = isCommentTask ? "正在采集评价数据" : "正在采集数据";
                    body.prepend(bar);

                    // 进入准备状态 - 如果没有数据那么则等待3秒后重试3次
                    selectors = msg.selectors
                    selectors1 = msg.selectors1
                    postReadyMessage(5)
                    // port.postMessage({ cmd: 'ready' });
                }
            }, defaultTimeout)
            return
        }

        // 采集本页数据
        if (msgCmd === 'collect') {
            selectors = msg.selectors
            selectors1 = msg.selectors1
            console.log('selectors', selectors, selectors1)

            // 不同逻辑(兼容2种)
            if (selectors || selectors1) {
                if (isCommentTask) {
                    handleCollectComment(5)
                } else {
                    handleCollect(5)
                }
            }
            return
        }
    })

    // 发送准备就绪消息,3秒重试次数
    function postReadyMessage(trytimes) {
        console.log('postReadyMessage',)
        const elSelectors = selectorType === 1 ? selectors1 : selectors;

        if (!elSelectors) {
            port.postMessage({ cmd: 'ready' })
            return
        }
        const currCateList = document.querySelectorAll(selectors.skuItemCurrentList)
        if (currCateList.length) {
            port.postMessage({ cmd: 'ready' })
        } else if (trytimes > 0) {
            // 最后2次使用备用selector1
            if (trytimes < 2) {
                selectorType = 0
            }
            setTimeout(() => postReadyMessage(trytimes - 1), 1000)
        } else {
            port.postMessage({ cmd: 'error', value: '没有数据或者采集规则不匹配。' + window.location.href, close: true })
        }
    }
    ///////////

    // 处理采集评价数据，3秒重试次数
    function handleCollectComment(trytimes) {
        const elSelectors = selectorType === 1 ? selectors1 : selectors;
        commentSelectors = elSelectors.commentSelectors
        console.log("elSelectors.", commentSelectors)
        const commentElList = document.querySelectorAll(commentSelectors.list)
        if (!commentElList.length && trytimes > 0) {
            setTimeout(() => handleCollectComment(trytimes - 1), defaultTimeout)
            return
        }
        // 基础数据
        const itemData = getItemData()
        pushItemCommentDatas(itemData, 5)
    }
    // 采集评价数据
    function pushItemCommentDatas(itemData, trytimes) {
        const commentFn = selectorType === 1 ? getItemCommentData1 : getItemCommentData0

        const commentElList = document.querySelectorAll(commentSelectors.list)
        if (!commentElList.length) {
            if (trytimes > 0) {
                setTimeout(() => pushItemCommentDatas(itemData, trytimes - 1), defaultTimeout)
            } else {
                port.postMessage({ cmd: 'finished' })
            }
            return
        }

        const results = []
        for (const el of commentElList) {
            results.push(Object.assign({}, itemData, commentFn(el)))
        }
        port.postMessage({ cmd: 'result', value: results, close: false });

        // 下一页
        const nextPageBtn = document.querySelector(commentSelectors.nextPageBtn)
        if (nextPageBtn) {
            nextPageBtn.click()
            // 3秒后采集
            setTimeout(() => pushItemCommentDatas(itemData, 5), defaultTimeout)
        } else {
            // 执行完毕
            port.postMessage({ cmd: 'finished' })
        }
    }

    // 获取采集评价数据
    function getItemCommentData0(commentEl) {
        const row = {}
        const userNameEl = commentEl.querySelector(commentSelectors.userName)
        if (userNameEl) {
            row.user_name = userNameEl.textContent
        }

        const userLevelEl = commentEl.querySelector(commentSelectors.userLevel)
        if (userLevelEl) {
            row.user_level = userLevelEl.textContent
        }
        const starEl = commentEl.querySelector(commentSelectors.star)
        if (starEl) {
            const cl = starEl.classList
            if (cl.contains('star5')) {
                row.star = '5星'
            } else if (cl.contains('star4')) {
                row.star = '4星'
            } else if (cl.contains('star3')) {
                row.star = '3星'
            } else if (cl.contains('star2')) {
                row.star = '2星'
            } else if (cl.contains('star1')) {
                row.star = '1星'
            }
        }
        // <div class="order-info"><span>牛油果绿</span><span>100cm</span><span></span><span></span><span>2024-05-03</span><span>广东</span></div>
        const orderInfoEl = commentEl.querySelector(commentSelectors.orderInfo)
        if (orderInfoEl) {
            const children = orderInfoEl.children
            const len = children.length
            if (len >= 6) {
                row.comment_procity = children[5].textContent
            }
            if (len >= 5) {
                row.release_date = children[4].textContent
            }
            let skuTitle = ''
            const oiLen = Math.min(4, len)
            for (let i = 0; i < oiLen; i++) {
                skuTitle = skuTitle + ' ' + children[i].textContent
            }
            row.sku_title = skuTitle.trim()
        }

        const contentEl = commentEl.querySelector(commentSelectors.content)
        if (contentEl) {
            row.content = contentEl.textContent.trim()
        }

        const imgUrlEls = commentEl.querySelectorAll(commentSelectors.imgUrls)
        console.log('imgUrlEls', imgUrlEls)
        row.image_urls = []
        for (const imgEl of imgUrlEls) {
            let imgSrc = imgEl.src
            if (commentSelectors.imgUrlReplaceFrom && commentSelectors.imgUrlReplaceTo) {
                imgSrc = imgSrc.replace(commentSelectors.imgUrlReplaceFrom, commentSelectors.imgUrlReplaceTo)
            }
            row.image_urls.push(imgSrc)
        }

        // // 追加评价
        // const appendNode = commentEl.querySelector(commentSelectors.appendNode)
        // if (appendNode) {
        //     const appendContentEl = appendNode.querySelector(commentSelectors.appendContent)
        //     row.appendContent = appendContentEl.textContent.trim()
        //     const appendImgUrlEls = appendNode.querySelectorAll(commentSelectors.appendImgUrls)
        //     row.append_image_urls = []
        //     for (const imgEl of appendImgUrlEls) {
        //         row.append_image_urls.push(imgEl.src)
        //     }
        // }


        // const replyEl = commentEl.querySelector(commentSelectors.reply)
        // if (replyEl) {
        //     row.reply = replyEl.textContent.replace('商家回复：', '').trim()
        // }

        return row
    }
    // 备用 获取采集评价数据 - 使用selector1
    function getItemCommentData1(commentEl) {
        return {}
    }

    ////////////////////
    // 处理采集数据，3秒重试次数
    function handleCollect(trytimes) {
        const elSelectors = selectorType === 1 ? selectors1 : selectors;

        // 获取skuCateList获取分类,一般颜色为第一个,尺寸为第二个
        const skuCateElList = document.querySelectorAll(elSelectors.skuCateList)

        console.log('handleCollect', trytimes, skuCateElList)

        if (!skuCateElList.length && trytimes > 0) {
            setTimeout(() => handleCollect(trytimes - 1), defaultTimeout)
            return
        }

        // 最多处理2个分类
        cate1ElList = skuCateElList[0];
        cate2ElList = skuCateElList.length >= 2 ? skuCateElList[1] : null;

        console.log('cate1ElList', cate1ElList, cate2ElList)

        // 当前选择的分类
        cate1SkuItemElList = cate1ElList.querySelectorAll(elSelectors.skuItemList)

        // 选中的当前分类
        const currItemList = document.querySelectorAll(elSelectors.skuItemCurrentList)
        if (currItemList.length) {
            currCate1ItemEl = currItemList[0]
            currCate2ItemEl = currItemList.length >= 2 ? currItemList[1] : null;
        }
        for (let i = 0; i < cate1SkuItemElList.length; i++) {
            if (cate1SkuItemElList[i] === currCate1ItemEl) {
                cate1ItemElIndex = i
            }
        }

        // 第二个分类
        if (cate2ElList) {
            cate2SkuItemElList = cate2ElList.querySelectorAll(elSelectors.skuItemList)
            for (let i = 0; i < cate2SkuItemElList.length; i++) {
                if (cate2SkuItemElList[i] === currCate2ItemEl) {
                    cate2ItemElIndex = i
                }
            }
        }

        if (isJyFirst) {
            if (cate1ItemElIndex > 0) {
                window.location.href = `https://item.jd.com/${cate1SkuItemElList[0].dataset.sku}.html?_jyfirst_=1`
                return
            }
            if (cate2ItemElIndex > 0) {
                window.location.href = `https://item.jd.com/${cate2SkuItemElList[0].dataset.sku}.html`
                return
            }

            window.location.href = `https://item.jd.com/${cate1SkuItemElList[0].dataset.sku}.html`
        } else if (isJyNext) {
            if (cate2ItemElIndex > 0) {
                window.location.href = `https://item.jd.com/${cate2SkuItemElList[0].dataset.sku}.html`
                return
            }
        }

        // 采集数据
        pushItemData(5)
    }

    // 获取采集数据 - 使用selector
    function getItemData() {
        if (!dataLoaded()) {
            return null;
        }
        const row = { platform: 'jd' }

        // 商品链接
        row.auction_url = window.location.href.replaceAll('#comment', '').replaceAll('_jytype_=comment', '')
        if (row.auction_url.endsWith('?')) {
            row.auction_url = row.auction_url.substring(0, row.auction_url.length - 1)
        }

        // 商品ID
        const itemRl = row.auction_url.match(new RegExp('^https://item.jd.com/(.+).html*'))
        if (itemRl && itemRl.length > 1) {
            row.item_id = itemRl[1]

            // 聊天url
            // https://jdcs.jd.com/index.action?_t=&pid=10077100293506
            row.chat_url = `https://jdcs.jd.com/index.action?_t=&pid=${row.item_id}`
        }

        // 店铺信息
        const shopEl = document.querySelector(selectors.shop)
        if (shopEl) {
            row.shop_title = shopEl.innerText
            row.shop_name = shopEl.innerText
            row.shop_url = shopEl.href
            row.nick = shopEl.innerText
            if (shopEl.href) {
                const rl = shopEl.href.match(new RegExp('//mall.jd.com/index-(.+).html'))
                if (rl && rl.length > 1) {
                    row.shop_id = rl[1]
                }
            }
        }

        // 标题
        const titleEl = document.querySelector(selectors.title)
        if (titleEl) {
            row.title = titleEl.textContent.trim()
        }

        // 省市,正则表达式从(山东泰安市)发货
        const procityEl = document.querySelector(selectors.procity)
        if (procityEl) {
            const rl = procityEl.textContent.match(new RegExp('从 (.+) 发货'))
            if (rl && rl.length > 1) {
                row.procity = rl[1]
            }
        }

        // 销量
        const realSalesEl = document.querySelector(selectors.realSales)
        if (realSalesEl) {
            row.real_sales = realSalesEl.textContent.trim()
        }

        // 价格
        const cpriceEl = document.querySelector(selectors.cPrice)
        if (cpriceEl) {
            row.price = cpriceEl.textContent.trim().replaceAll('￥', '')
        }

        // 到手价格
        const priceWithRateEl = document.querySelector(selectors.price_with_rate)
        if (priceWithRateEl) {
            row.price_with_rate = priceWithRateEl.textContent.trim()
        }

        // 商品主图
        let mainPicEl = document.querySelector(selectors.mainPic)
        if (mainPicEl) {
            row.pic_path = mainPicEl.src
        }

        row.sku_id = row.item_id

        // 颜色尺码规格
        const currCateList = document.querySelectorAll(selectors.skuItemCurrentList)
        if (currCateList.length) {
            const value = currCateList[0].dataset.value
            const parentId = currCateList[0].parentElement.parentElement.id
            if (parentId === 'choose-attr-1') {
                row.sku_cate1 = value
            } else if (parentId === 'choose-attr-2') {
                row.sku_cate2 = value
            }
        }
        if (currCateList.length >= 2) {
            const value = currCateList[1].dataset.value
            const parentId = currCateList[1].parentElement.parentElement.id
            if (parentId === 'choose-attr-1') {
                row.sku_cate1 = value
            } else if (parentId === 'choose-attr-2') {
                row.sku_cate2 = value
            }
        }

        // 优惠券
        const couponInfoEl = document.querySelector(selectors.couponInfo)
        if (couponInfoEl) {
            row.coupon_info = couponInfoEl.textContent.trim()
        }
        // 活动
        if (selectors.activeInfo) {
            const activeInfoEl = document.querySelector(selectors.activeInfo)
            if (activeInfoEl) {
                row.active_info = activeInfoEl.textContent.trim()
            }
        }
        console.log('row', row)
        return row
    }

    // 数据已经载入
    function dataLoaded() {
        const cpriceEl = document.querySelector(selectors.cPrice)
        if (cpriceEl) {
            return cpriceEl.textContent.trim().replaceAll('￥', '').length > 0
        }
        return false
    }

    // 获取采集数据,并写入results
    function pushItemData(trytimes) {
        console.log('getItemData:', cate1ItemElIndex, cate2ItemElIndex, results)
        const itemData = getItemData()
        if (itemData == null) {
            setTimeout(() => pushItemData(trytimes - 1), defaultTimeout)
            return
        }

        let finished = cate1ItemElIndex >= cate1SkuItemElList.length - 1;
        if (finished && cate2SkuItemElList) {
            finished = cate2ItemElIndex >= cate2SkuItemElList.length - 1;
        }
        // 上传当前页面数据，每页时单独采集的
        port.postMessage({ cmd: 'result', value: [itemData], close: finished });

        if (finished) {
            return;
        }

        if (cate2ElList) {
            // 点击下个cate2项目
            cate2ItemElIndex = cate2ItemElIndex + 1
            if (cate2ItemElIndex >= cate2SkuItemElList.length) {
                // 移动cate1ItemElIndex
                cate1ItemElIndex = cate1ItemElIndex + 1
                console.log('cate1ItemElIndex', cate1ItemElIndex, cate1SkuItemElList.length)
                if (cate1ItemElIndex >= cate1SkuItemElList.length) {
                    return
                }
                // 点击下一个cate1
                // cate1SkuItemElList[cate1ItemElIndex].click()
                window.location.href = `https://item.jd.com/${cate1SkuItemElList[cate1ItemElIndex].dataset.sku}.html?_jynext_=1`
                return
            } else {
                // 点击下一个cate2
                // cate2SkuItemElList[cate2ItemElIndex].click()
                window.location.href = `https://item.jd.com/${cate2SkuItemElList[cate2ItemElIndex].dataset.sku}.html`
                return
            }
        } else {
            // 移动cate1ItemElIndex
            cate1ItemElIndex = cate1ItemElIndex + 1
            if (cate1ItemElIndex >= cate1SkuItemElList.length) {
                return
            }
            // 点击下一个cate1
            // cate1SkuItemElList[cate1ItemElIndex].click()
            window.location.href = `https://item.jd.com/${cate1SkuItemElList[cate1ItemElIndex].dataset.sku}.html?_jynext_=1`
            return
        }
    }

    function getUrlParam(url, paramName) {
        const searchParams = new URLSearchParams(new URL(url).search);
        return searchParams.get(paramName);
    }
})()